package cz.muni.fi.pa165.rating;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;

@RestController
@RequestMapping("/ratings")
public class RatingController {

    private final RatingService ratingService;

    @Autowired
    public RatingController(RatingService ratingService) {
        this.ratingService = ratingService;
    }

    @GetMapping
    public List<RatingDto> getRatings() {
        return ratingService.getRatings();
    }

    @PostMapping
    public void createRating(@Valid @RequestBody RatingDto ratingDto) {
        ratingService.createRating(ratingDto);
    }
    
    @PostMapping("{id}")
    public void updateRating(@PathVariable long id, @Valid @RequestBody RatingDto ratingDto) {
        ratingService.updateRating(id, ratingDto);
    }

    @DeleteMapping("{id}")
    public void deleteRating(@PathVariable long id) {
        ratingService.deleteRating(id);
    }

    @DeleteMapping
    public void deleteAllRatings() {
        ratingService.deleteAllRatings();
    }

    @GetMapping("{id}")
    public RatingDto getById(@PathVariable long id) {
        return ratingService.getById(id);
    }
}
